<?php


class CreationVideoSpecialDataProvider
{
    private $wp_caller = null;

    public function __construct()
    {
        $this->wp_caller = Wp_caller::getInstance();
    }

    public function siteUrl()
    {
        $result = site_url();
        $result = str_replace('https', 'http', $result);
        $result = str_replace('http://', '', $result);
        return esc_url($result);
    }
	
	public function IA_description($question_ia,$id_product)
    {
        //retrouver la description du produit
		//son nom et son PRIX
	    //utiliser la question pour obtenir le retour
		$result="";
		$uid_response="";
		
		//return 'question_ia:|'.$question_ia.'|'.$id_product;
		
		if ($id_product!='') {
            $productTemp = new WC_Product($id_product);
		} else {
			return '';
		}
		
		if ($question_ia=='') {
			return '';
		}

		
		
		$context="Nom du produit : ".$productTemp->get_name().", vendu : ".$productTemp->get_price().$this->devise().", description du produit :	".$productTemp->get_description();
		$ch = curl_init();
		$responseAPI = null;
		$datas =array("token"=>"be3c9b8c02e9d-6ace-10cc-fb99-66c344c54ce3e81eea",
				"action"=>"set_request",
				"type"=>"text_generation",
				"model"=>"gpt-4o",
				"temperature"=>0.7,
				"max_tokens"=>150,
				"nb_response"=>1,
				"system_content"=>$context,
				"user_content"=>$question_ia
				);
		try {
			curl_setopt($ch, CURLOPT_URL, "https://ip120.ip-5-196-165.eu/API_v2/ai.php");
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $datas);
			curl_setopt($ch, CURLOPT_HEADER, false);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
			curl_setopt($ch, CURLOPT_TIMEOUT, 5);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
			curl_setopt($ch, CURLOPT_MAXREDIRS, 1);
			//curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);

			$response = curl_exec($ch);

			if (curl_errno($ch)) {
				
				$result =curl_error($ch);
				
			}

			$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			if ($http_code == intval(200)) {
				if ($response != false) {
					//$result.='retour api|'.$response.'|';
					$response = json_decode($response, true);
					//$result.='uid|'.$response['uid'].'|';
					//$result=$response['uid'];
					$uid_response=$response['uid'];
					
				}
			}
		} catch (\Throwable $th) {
			throw $th;
		} finally {
			curl_close($ch);
		}
		
		
		if ($uid_response!="") {
			$i=0;
			while ($i <= 120) {
				$i++;  
				sleep(1);
				//$result.="tentative".intval($i);
				//tentative obtention résultat
				$ch = curl_init();
				$datas =array("token"=>"be3c9b8c02e9d-6ace-10cc-fb99-66c344c54ce3e81eea",
					"action"=>"get_response",
					"full"=>"false",
					"uid"=>$uid_response
				);
				try {
					curl_setopt($ch, CURLOPT_URL, "https://ip120.ip-5-196-165.eu/API_v2/ai.php");
					curl_setopt($ch, CURLOPT_POST, true);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
					curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $datas);
					curl_setopt($ch, CURLOPT_HEADER, false);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
					curl_setopt($ch, CURLOPT_TIMEOUT, 5);
					curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
					curl_setopt($ch, CURLOPT_MAXREDIRS, 1);
					//curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);

					$response = curl_exec($ch);

					if (curl_errno($ch)) {
						
						$result =curl_error($ch);
						
					}

					$http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
					if ($http_code == intval(200)) {
						if ($response != false) {
							//$result.='retour api|'.$response.'|';
							$response = json_decode($response, true);
							//$result.='status|'.$response['status'].'|';
							if ($response['status']=='success') {
								//$result.='reussite|'.$response['response'][0].'|';
								if ($response['response']>0) {
									
									$response['response'][0] = str_replace('"', "", $response['response'][0]);
									
								    $result=$response['response'][0];
								}
								break;
							}
							
						}
					}
				} catch (\Throwable $th) {
					throw $th;
				} finally {
					curl_close($ch);
				}
				
				
				
			} 
		}
		return $result;
    }

    private function capitalizeAndRemoveSpaces($string)
    {
        // Mettre la première lettre de chaque mot en majuscule
        $string = ucwords($string);

        // Supprimer les espaces
        $string = str_replace(' ', '', $string);

        return $string;
    }

    public function replace_unicode_escape_sequence($match)
    {
        return mb_convert_encoding(pack('H*', $match[1]), 'UTF-8', 'UCS-2BE');
    }

    public function unicode_decode($str)
    {
        return preg_replace_callback('/u([0-9a-f]{4})/i', 'replace_unicode_escape_sequence', $str);
    }

    private function decode_accents_ds($str)
    {
        //return unicode_decode($str);
        return $str;
    }

    public function getyoutubevideo($product_id)
    {
        $data_youtube=array();
        $data_youtube['titleVideo']='title';
        $data_youtube['summaryVideo']='description';
        $data_youtube['tagsVideo']='';
        //[Nom du produit] + [«  -  » + Première catégorie du produit si la somme des deux n 'excède pas 65 caractères, sinon que Nom du produit]
        if ($product_id!='') {
            $productTemp = new WC_Product($product_id);
            $terms =  get_the_terms($product_id, 'product_cat');
            if ($terms && ! is_wp_error($terms)) {
                $premiere_cat_produit = $this->decode_accents_ds($terms[0]->name);
            } else {
                $premiere_cat_produit = "";
            }
            if ($premiere_cat_produit!="") {
                $temp_chaine = $this->decode_accents_ds($productTemp->get_name()). ' - '.$premiere_cat_produit;
                if (strlen($temp_chaine)> 65) {
                    $temp_chaine = $this->decode_accents_ds($productTemp->get_name());
                }
            } else {
                $temp_chaine = $this->decode_accents_ds($productTemp->get_name());
            }
            $data_youtube['titleVideo']=substr($temp_chaine, 0, 100);

            $description = $productTemp->get_description()."\r\n"
                            ."\r\n"
                            ."\r\n";
            if ($premiere_cat_produit!="") {
                $description .=$premiere_cat_produit."\r\n"
                            ."\r\n"
                            ."\r\n";
            }

            $description .="🔥🔥Acheter ".$this->decode_accents_ds($productTemp->get_name())." 🔥🔥"."\r\n"
                            .$this->siteName()." : ".get_permalink($product_id)."\r\n"
                            ."\r\n"
                            ."\r\n"
                            ."______________________________________________________";

            $data_youtube['summaryVideo']=substr($description, 0, 5000);

            $tags='#'.$this->capitalizeAndRemoveSpaces($this->decode_accents_ds($productTemp->get_name()));

            if ($premiere_cat_produit!="") {
                $tags.=', #'.$this->capitalizeAndRemoveSpaces($premiere_cat_produit);
            }
            $data_youtube['tagsVideo']=substr($tags, 0, 250);


            /*
            #[Nom du produit dont on supprime tous les espaces mais on met une majuscule la première lettre qui suivrait un espace supprimé]    et    #[Première catégorie du produit dont on supprime tous les espaces mais on met une majuscule la première lettre qui suivrait un espace supprimé]
            */
        }


        return $data_youtube;
    }

    public function first_category()
    {
        return $this->decode_accents_ds($terms[0]->name);
    }

    public function siteName()
    {
        return get_bloginfo('name');
    }

    public function siteLogo()
    {
        $sileIconUrl=Tools_DS4::getModuleUrl()."Files/no.png";
		$siteIconPartPath=WP_PLUGIN_DIR."/digitalsignage/Files/no.png";
		$custom_logo_id = get_theme_mod('custom_logo'); // Récupère l'ID du logo
		$logo = wp_get_attachment_image_src($custom_logo_id, 'full'); // Récupère l'URL du logo
		if (has_custom_logo()) {
			$sileIconUrl = esc_url($logo[0]); // Retourne l'URL absolue du logo
			$logo_path = get_attached_file($custom_logo_id); // Récupère le chemin absolu du fichier local
			if ($logo_path) {
				//return $logo_path; // Retourne le chemin absolu en local
				return $sileIconUrl.";".$logo_path;
			}		
		}
		
		return $sileIconUrl.";".$siteIconPartPath;
		/*
		$sileIconUrl      = get_site_icon_url();

        //Prestashop
        //$siteIconPartPath = str_replace(get_site_url() , $_SERVER["DOCUMENT_ROOT"] . "/", $sileIconUrl);

        //WooCommerce
        $siteIconPartPath = str_replace(get_site_url(), ABSPATH, $sileIconUrl);

        $siteIconPartPath = str_replace('\\', '/', $siteIconPartPath);
        $siteIconPartPath = str_replace('//', '/', $siteIconPartPath);

        return $sileIconUrl.";".$siteIconPartPath;
		*/
		
    }

    public function watermarkPlacement()
    {
        $watermarkSettings = $this->wp_caller->get_data(Wp_caller::WATERMARK);
        if ($this->watermarkDataIsRight($watermarkSettings)) {
            return $watermarkSettings['watermark_place'];
        }

        return "";
    }

    public function watermarkPicture()
    {
        $sileIconUrl      = Tools_DS4::getModuleUrl()."Files/watermark.png";
        //$siteIconPartPath = str_replace(get_site_url() , $_SERVER["DOCUMENT_ROOT"] . "/", $sileIconUrl);
        $siteIconPartPath = str_replace(get_site_url(), ABSPATH, $sileIconUrl);

        $siteIconPartPath = str_replace('\\', '/', $siteIconPartPath);
        $siteIconPartPath = str_replace('//', '/', $siteIconPartPath);

        return $sileIconUrl.";".$siteIconPartPath;
    }

    private function watermarkDataIsRight($watermarkSettings)
    {
        if ($watermarkSettings && isset($watermarkSettings['watermark_active']) && $watermarkSettings['watermark_active'] && isset($watermarkSettings['watermark_place'])) {
            $watermarkImage = Tools_DS4::getModuleImgDir() . "watermark.png";
            if (file_exists($watermarkImage)) {
                return true;
            }
        }
        return false;
    }

    public function devise()
    {
        return Tools_DS4::getWooCommerceDevice();
    }

    public function currency()
    {
        return $this->devise();
    }

    public function priceCurrencyAlign()
    {
        $priceFormat = $this->wp_caller->get_data(Wp_caller::PRIX_FORMAT);
        if ($priceFormat) {
            $priceFormat = intval($priceFormat);
            if (in_array($priceFormat, array( 0, 1, 2, 3, 4, 5, 6, 7 ))) {
                return -1; // symbole monetaire a gauche
            } elseif (in_array($priceFormat, array( 16, 17, 18 ))) {
                return 0; // symbole monetaire au milieux
            }
        }
        return 1; // symbole monetaire a droit
    }

    public function priceCentValign()
    {
        $priceFormat = $this->wp_caller->get_data(Wp_caller::PRIX_FORMAT);
        if ($priceFormat) {
            $priceFormat = intval($priceFormat);
            if (in_array($priceFormat, array( 1, 4, 6, 9, 12, 14, 17 ))) {
                return 1; // centime puissance haut
            } elseif (in_array($priceFormat, array( 2, 5, 7, 10, 13, 15, 18 ))) {
                return -1; // centime puissance bas
            }
        }
        return 0; // centime sans puissance
    }

    public function priceDecimalSeparator()
    {
        $priceFormat = $this->wp_caller->get_data(Wp_caller::PRIX_FORMAT);
        if ($priceFormat) {
            $priceFormat = intval($priceFormat);
            if (in_array($priceFormat, array( 6, 7, 14, 15, 16, 17, 18 ))) {
                return ""; // pas de separateur
            } elseif (in_array($priceFormat, array( 0, 1, 2, 8, 9, 10 ))) {
                return "."; // separateur point
            }
        }
        return ","; // separateur virgule
    }

    public function videoWidth()
    {
        $resolution = Wp_caller::getInstance()->get_data(Wp_caller::RESOLUTION);
        $resolutionsWH = explode("x", $resolution);
        return $resolutionsWH[0];
    }


    public function videoHeight()
    {
        $resolution = Wp_caller::getInstance()->get_data(Wp_caller::RESOLUTION);
        $resolutionsWH = explode("x", $resolution);
        return $resolutionsWH[1];
    }
}
