<?php

    require_once __DIR__ . "/../Kernel/API/Entity/DemandeEntity.php";
    require_once __DIR__ . "/../Kernel/API/Manager/DemandeManager.php";
    require_once __DIR__ . "/../Kernel/API/Manager/DigitalSignageException.php";
    require_once __DIR__ . "/../Kernel/API/Manager/PlaylistManager.php";
	//require_once __DIR__  ."/../controllers/VideoController.php";


    class FrontShortcodeVideoDisplayer
    {
        public function __construct()
        {
            //recup token
			$wp = new Wp_caller();
			$token = $wp->get_data(Wp_caller::FORFAIT);
            if ($token) {
				ForfaitManager::instance()->setForfait($token);
			}
			$forfait = ForfaitManager::instance()->getForfait(ForfaitManager::instance()->getToken(),true);
			if (!$forfait) {
				//on ne fait rien
			} else {
				
				if ($forfait->isExpired()) {
					$videocontroller = new VideoController();
					$videocontroller->deleteDirectory(__DIR__ . "/../Videos/");
				} else {
					//add_action('woocommerce_after_single_product', array($this, 'ProductPlacement5'));

					add_filter('woocommerce_short_description', array($this, 'ProductPlacement12'));
					add_filter('the_content', array($this, 'ProductPlacement34'));

					add_filter('woocommerce_single_product_image_thumbnail_html', array($this, 'ProductPlacement6'));//ok
					add_action( 'woocommerce_after_single_product_summary', array($this,'ProductPlacement_en_dessous_thumbnail'), 6 );
					
					add_shortcode('digitalsignage4', array($this, 'shortcode_video'));
					add_shortcode('digitalsignage4_playlist', array($this, 'shortcode_playlist'));
				
				}
				
			}	
        }

        public static function init()
        {
            new FrontShortcodeVideoDisplayer();
        }

        public function ProductPlacement5($datas)
        {
            if ($this->checkPlacementActive('placement_5')) {
                $video = json_encode($this->shortcode_video(array(), false));

                echo ("
			<script>

                    digitalSignageAddPlace();
                    
                        function digitalSignageAddPlace(){
                            
                            let imagesGalerie = document.querySelector('#main > .product > .woocommerce-product-gallery > .flex-control-nav');
                            
                            if(imagesGalerie && imagesGalerie.innerHTML){
                                
                                      let div = document.createElement('div');
		                              div.innerHTML = $video;
									  
                                      let video = div.firstChild;
                                      video.style.marginTop = '20px';
								      imagesGalerie.parentNode.insertBefore( video, imagesGalerie.nextElementSibling ) ;
                              
                            }else{
                                
                               setTimeout(
	                            digitalSignageAddPlace,
	                            100
	                          )
	                          
                            }
                            
                        }
                        
			</script>");
            }

            return $datas;
        }


        private static $placement6Charged = false;

        public function ProductPlacement6($data)
        {
            $videoElementBalise = "";
            $script = "";
            if ($this->checkPlacementActive('placement_6')) {
                if (!self::$placement6Charged) {
                    if ($this->productHaveVideo()) {
                        $urlImage = Tools_DS4::getModuleUrl() . "Kernel/Views/img/play_box.png";
                        //$videoBalise = $this->shortcode_video(array('width'=> 'max-width:100%','height' => 'max-height:100%'), TRUE);
                        $videoBalise = $this->shortcode_video(array('width'=> 'position:absolute;top:0;left:0;width:100%;height:100%;object-fit:cover;','height'=>''), true);
                        //$videoBalise = $this->shortcode_video(array('width'=> 'position:absolute;top:0;left:50%;transform:translateX(-50%);max-width:100%;max-height:100%;','height'=>''), TRUE);
                        if ($videoBalise) {
                            $videoElementBalise = (' 
							<div data-thumb="' . $urlImage . '" data-thumb-alt="" class="woocommerce-product-gallery__image flex-active-slide" style="position: relative; overflow: hidden; width: 323.817px; margin-right: 0px; float: left; display: block;">
									<div style="min-width: 100%;padding-top: 100%;position: relative;">
										'.$videoBalise.'
									</div>
							</div>
							');
                            /*
                            $videoElementBalise = '
                            <div data-thumb="' . $urlImage . '" data-thumb-alt="" class="woocommerce-product-gallery__image flex-active-slide" style="position: relative; overflow: hidden; width: 323.817px; margin-right: 0px; float: left; display: block;">
                                    <div style="min-width: 100%;padding-top: 100%;position: relative;">
                                        <video controls loop="" style="position:absolute;top:0;left:0;max-width:100%;max-height:100%;object-fit:cover;" preload="auto" autoplay="autoplay"  muted="muted" class="wp-post-image"  title="Video" data-caption=""  data-large_image_width="800" data-large_image_height="800" draggable="false">
                                            ' . $this->shortcode_video(array(), TRUE) . '
                                        </video>
                                    </div>
                            </div>
                            ';
                            */
                        }

                        $script = ("
                        <script>
                        
                        let inter = setInterval(
                            () => {
                                
                                //Si le produit na pas dimage
                                let placeHolder = document.querySelector('.woocommerce-product-gallery__image--placeholder')
                                if(placeHolder){
                                    let parent =  placeHolder.parentElement;
                                    parent.removeChild(placeHolder);
                                    document.querySelector('.woocommerce-product-gallery__trigger').style.opacity = '0';
                                    parent.firstElementChild.style.width = '100%';
                                    parent.replaceChild(parent.firstElementChild.cloneNode(true), parent.firstElementChild);
                                    parent.firstElementChild.addEventListener('click', function (event) {
                                        event.stopPropagation();
                                    });
                                    clearInterval(inter);
                                }
                                
                                
                                //Si el produit a des images
                                let controllers = document.querySelector('.flex-control-nav');
                                if(controllers){
                                    let myController = controllers.firstElementChild;
                                       myController.style.padding = '10px';
                                    
                                    let loupe = document.querySelector('.woocommerce-product-gallery__trigger');
                                    
                                    if(document.querySelector('.woocommerce-product-gallery__wrapper').firstElementChild.classList.contains('flex-active-slide')){
                                        myController.firstElementChild.style.border = '2px solid rgb(206, 193, 206)';
                                       loupe.style.opacity = '0';
                                    }
                                        
                                    loupe.style.transition = '200ms';
                                    controllers.addEventListener('click' , (e) => {
                                        if(e.target === myController || e.target === myController.firstElementChild){
                                            myController.firstElementChild.style.border = '2px solid rgb(206, 193, 206)';
                                            loupe.style.opacity = '0';
                                        }else{
                                            myController.firstElementChild.style.border = '0px solid grey';
                                            loupe.style.opacity = '1';
                                        }
                                    });
                                    clearInterval(inter);
                                }
                                
                            },
                            10
                        )
                        
                      
                        </script>
                        ");
                    }
                    self::$placement6Charged = true;
                }
            }
			
            echo $videoElementBalise . $data . $script;
        }
		
		public function ProductPlacement_en_dessous_thumbnail($src) {
			
			$finalHtml = "";

            if ($this->checkPlacementActive('placement_5')) {
                $finalHtml .= $this->shortcode_video(array('no_decalage' => true));
            }

            
			echo $finalHtml;
		}
		

        public function ProductPlacement12($shortDescriptionContent)
        {
            $finalHtml = "";

            if ($this->checkPlacementActive('placement_1')) {
                $finalHtml .= $this->shortcode_video(array('no_decalage' => true));
            }

            $finalHtml .= '<p>' . $shortDescriptionContent . '<p>';

            if ($this->checkPlacementActive('placement_2')) {
                $finalHtml .= $this->shortcode_video(array('no_decalage' => true));
            }

			return ($finalHtml);
        }

        public function ProductPlacement34($descriptionContent)
        {
            $finalHtml = "";

            if ($this->checkPlacementActive('placement_3')) {
                $finalHtml .= $this->shortcode_video(array('no_decalage' => true));
            }

            $finalHtml .= '<p>' . $descriptionContent . '<p>';

            if ($this->checkPlacementActive('placement_4')) {
                $finalHtml .= $this->shortcode_video(array('no_decalage' => true));
            }
			return ($finalHtml);
        }


        private function checkPlacementActive($placement)
        {
            $wp = new Wp_caller();
            if ($datas = $wp->get_data(Wp_caller::PLACEMENT)) {
                if (array_key_exists($placement, $datas) && $datas[$placement] == 'on') {
                    return true;
                }
            }

            return false;
        }


        public function shortcode_video($params, $onlySource = false)
        {
            global $product;

            $video = $this->getVideoForShortcode(($product) ? $product->get_id() : null, (isset($params['id'])) ? $params['id'] : null);
            if ($video && $video->getVideoUrl()) {
                $extra = (in_array('noLoop', $params)) ? '0' : '1';
				
				$no_decalage = (in_array('no_decalage', $params)) ? true : false;
				
                if ($onlySource) {
                    return ($video->getVideoPlayer($params['width'], $params['height'], $extra, '1',$no_decalage));
                } else {
                    return ($video->getVideoPlayer('max-width: 600px;width: 600px', 'max-height:500px;height: 500px', $extra, '1',$no_decalage));
                }
            }
            return "";
        }


        
        private function getVideoForShortcode($id_product, $id_video = null)
        {
            if ($id_video) {
                return $this->getVideoFromIdDemande($id_video);
            } else {
                if ($id_product) {
                    try {
                        $idVideo = DisplayedVideoProduct::getDisplayedVideoProduct($id_product);
                        return $this->getVideoFromIdDemande($idVideo);
                    } catch (Exception $e) {
                        return $this->getVideoLastFromProduct($id_product);
                    }
                }
            }
            return false;
        }

        private function getVideoLastFromProduct($id_product)
        {
            $demandeManager = new DemandeManager(Wp_caller::getInstance());
            $videoL = $demandeManager->getLocalDemandes("SELECT * FROM %s WHERE `product_id` = " . $id_product);
            if (isset($videoL[0]) && $videoL[0] instanceof DemandeEntity) {
                return $videoL[0];
            }
            return false;
        }

        private function getVideoFromIdDemande($id_video)
        {
            $demandeManager = new DemandeManager(Wp_caller::getInstance());
            $videoL = $demandeManager->getLocalDemandes("SELECT * FROM %s WHERE `id_demande` = " . $id_video);
            if (isset($videoL[0]) && $videoL[0] instanceof DemandeEntity) {
                return $videoL[0];
            }
            return false;
        }

        public function shortcode_playlist($params)
        {
            if (isset($params['id'])) {
                $playlist = PlaylistManager::set(Wp_caller::getInstance())->get_playlist($params['id']);
                if ($playlist && $playlist->get_active() && $videos = $playlist->get_videos()) {
                    
                    $videos = array_slice($videos, 0, $playlist->get_limit());

                    $videosMp4 = array_map(function ($id) {
                        $localDemandes = DemandeManager::set(Wp_caller::getInstance())->getLocalDemandes("SELECT * FROM %s WHERE `id_demande` = " . $id);
                        $localDemande = $localDemandes[0];

                        return $localDemande->getVideoUrl();
                    }, $videos);

                    $random = rand(0, 100000);

                    if ($videos) {
                        $baliseHtmlVideo = ('<video  id="' . $random . '" style="max-width: 600px;max-height:600px;" class="" preload="auto" autoplay="autoplay"  muted="muted" width="600" onended="onVideoEnded();">
				                        <source id="' . $random . '_mp4" src="" type="video/mp4">
				                        <!--source id="' . $random . '_ogv" src="" type="video/ogg"-->
				                    </video>');
				                    
				        $baliseHtmlVideo .= ('<script>        
				                    
					                    var video_list      = ' . json_encode($videosMp4) . ';
					                    			var video_index     = 0;
								        var video_player    = null;
					                    
					                    onload();
					                    
								        function onload(){
								    //        console.log("body loaded");
								            video_player  = document.getElementById("' . $random . '");
								            document.getElementById("' . $random . '_mp4").setAttribute("src", video_list[video_index]);
								            video_player.play();
								        }
								
								        function onVideoEnded(){
								            if(video_index < video_list.length - 1){
								                video_index++;
								            }
								            else{
								                video_index = 0;
								            }
                                            
								            document.getElementById("' . $random . '_mp4").setAttribute("src", video_list[video_index]);
                                            
                                            video_player.load();
								            video_player.play();
								        }
                                    
						      	  </script>');


                        return $baliseHtmlVideo;
                    }
                }
            }


            return "";
        }

        private function productHaveVideo()
        {
            try {
                global $product;
                $id_product = $product->get_id();
                $videoL = DemandeManager::set(Wp_caller::getInstance())->getLocalDemandes("SELECT * FROM %s WHERE `product_id` = " . $id_product);

                return !empty($videoL);
            } catch (DigitalSignageException $e) {
                return false;
            }
        }
    }
