<?php

    require_once "AutomatisationEntity.php";
    require_once "ForfaitEntity.php";
    require_once "APIResponseEntity.php";
    require_once "CompteEntity.php";
    require_once "DemandeEntity.php";
    require_once "GabaritEntity.php";
    require_once "PlaylistEntity.php";

    class Entity
    {
        /**
         * @param $datas
         *
         * @return Entity $this
         * @throws Exception
         */
        public function hydrate($datas)
        {
            foreach ($datas as $attribut => $value) {
                $method = 'set' . str_replace(' ', '', ucwords(str_replace('_', ' ', $attribut)));

                if (is_callable(array( $this, $method ))) {
                    if (gettype($value)=="string") {
                        $value =stripslashes($value);
                    }
                    $this->$method($value);
                }
            }

            return $this;
        }
    }
