<?php

    require_once __DIR__ . "/../Classes/Tools_DS4.php";
    require_once __DIR__ . "/../Kernel/Translations/DigitalSignageTranslate.php";
    require_once __DIR__ . "/../Classes/Wp_caller.php";
    require_once __DIR__ . "/../Kernel/API/Entity/DemandeEntity.php";
    require_once __DIR__ . "/../Kernel/API/Entity/PlaylistEntity.php";
    require_once __DIR__ . "/../Kernel/API/Manager/DemandeManager.php";
    require_once __DIR__ . "/../Kernel/API/Manager/DigitalSignageException.php";
    require_once __DIR__ . "/../Kernel/API/Manager/PlaylistManager.php";
    require_once __DIR__ ."/../Kernel/API/Manager/GabaritManager.php";

    class GabaritController extends DigitalSignageController
    {
        public function generatePage()
        {
            $this->route();
        }

        private function route()
        {
            if (isset($_GET['id_gabarit'])) {
                $this->display_gabarit();
            } else {
                $this->display_gabarits();
            }
        }

        private function display_gabarit()
        {
        }



        private function display_gabarits()
        {
            $gabarits = GabaritManager::instance()->getGabarits();

            $clean_path=WP_PLUGIN_DIR."/digitalsignage/Files/no.png";
            $clean_path=str_replace('\\', "/", $clean_path);

            $this->assign(array(
                'gabarits' => $gabarits,
                'urlSpecialData' => Tools_DS4::getModuleUrl()."Classes/CreationVideoSpecialDataProviderAjaxHandler.php?digitalSignageSpecialData=",
                'urlTraitement' => Tools_DS4::getModuleUrl().'controllers/override/AddGabaritCustomizeHandler.php',
                'urlLoadingImg' => Tools_DS4::getModuleUrl()."Kernel/Views/img/loadingChamp.gif",
                'urlnoImg' => Tools_DS4::getModuleUrl()."Files/no.png",
                'pathnoImg' => $clean_path,
                'logosite' => Tools_DS4::get_site_logo_url(),//get_site_icon_url(),
                'urlChangeDisplayedVideo' =>  Tools_DS4::getModuleUrl()."Classes/DisplayedVideoProductAjaxHandler.php",
            ));


            $this->setWPTemplate("../hook/front/adminGabaritCustomizeForm");
        }
    }
