<?php

    require_once __DIR__ . "/../../../Kernel/API/Entity/ForfaitEntity.php";
    require_once "Manager.php";

    class UpdateManager extends Manager
    {
        private static $managerEntityName = "Update";

        public static function get($currentVersion)
        {
            return self::getLastVersionUpdate($currentVersion);
        }

        private static function getLastVersionUpdate($currentversion)
        {
            $datas = self::getData($currentversion);
            if ($datas && !empty($datas)) {
                return end($datas);
            }
            return false;
        }

        private static function getData($currentVersion)
        {
            $demande = API_Linker::get(self::$managerEntityName . "?version=" . $currentVersion, ForfaitManager::instance()->getToken());

            if ($demande->getResponseCode() == 200) {
                return $demande->getDatas();
            }

            return false;
        }
    }
