const DIGITAL_SIGNAGE_BASE_URL = getScriptDirectoryUrl().replace("Kernel/Views/js/", "");

importScript("CronUpdateVideo");

function getScriptDirectoryUrl() {
    let scripts = document.getElementsByTagName('script');
    let myScript = scripts[scripts.length - 1];
    let myScriptFullUrl = myScript.src;
    let myScriptFullUrlSplit = myScriptFullUrl.split('/');
    myScriptFullUrlSplit.pop();
    return myScriptFullUrlSplit.join('/') + "/";
}

function importScript( scriptName ){
    let imported = document.createElement('script');
    imported.src = getScriptDirectoryUrl() + scriptName + '.js';
    document.head.appendChild(imported);
}