<?php

    //ini_set('display_errors', 1);
    //ini_set('display_startup_errors', 1);
    //error_reporting(E_ALL);

    if (file_exists("./../../../../../wp-load.php")) {
        define('WP_USE_THEMES', false); // Don't load theme support functionality
        require('./../../../../../wp-load.php');
    } else {
        require('./../../../../../config/config.inc.php');
        require('./../../../../../init.php');
        require_once"./../../../digitalsignage.php";
        DigitalSignageTranslate::setLang(substr(get_bloginfo('language'), 0, 2));
    }

    require_once __DIR__ . "/../../Classes/Tools_DS4.php";
    require_once __DIR__ . "/../../Kernel/API/Manager/DigitalSignageException.php";
    require_once __DIR__ . "/../../Kernel/Translations/DigitalSignageTranslate.php";
    require_once __DIR__ . "/../../Classes/Wp_caller.php";
    require_once __DIR__ . "/../../Kernel/API/Manager/DemandeManager.php";
    require_once __DIR__ . "/../../controllers/override/UpdateVideoHandleManager.php";

    if (isset($_FILES)) {
        if (isset($_FILES['file'])) {
			$uploaddir= Tools_DS4::getModuleDir().'../Files/';
            $uploaddir=str_replace('\\', "/", $uploaddir);

            $uploadfile = $uploaddir . "gabarit_customize_".sanitize_text_field($_POST['id_gabarit'])."_".sanitize_text_field($_POST['destination']).".png";
            
            $responseText="";
            if ($_FILES['file']['size'] > 0) {
                $overrides = [ 'test_form' => false ];
                $movefile = wp_handle_upload($_FILES['file'] , $overrides );
                
                if ( $movefile && empty( $movefile['error'] ) ) {
                    $watermarkUploaded = true;
                    $file_path = $movefile['file'];
                    unlink($uploadfile);
                    copy($file_path,$uploadfile);
                }
                else {
                    $watermarkUploaded = false;
                }

                if ($watermarkUploaded) {
                    chmod($uploadfile, 0777);
                }
                $url_file=Tools_DS4::getModuleUrl().'Files/'."gabarit_customize_".sanitize_text_field($_POST['id_gabarit'])."_".sanitize_text_field($_POST['destination']).".png";
                $responseText=$url_file.";".$uploadfile;
                
            }

            exit(json_encode($responseText));
        }
    }

    if (isset($_POST)) {
        $datas = $_POST;
        $gabaritManager = new GabaritManager();
        $gabarit = $gabaritManager->getGabarit($datas['gabarit']);
        $gabarit->setCustom($datas);
    }
